unit Unit1;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, ExtCtrls, ComCtrls, Menus, TeEngine, Series, TeeProcs, Chart;

 type
  TFNTimeCallBack = procedure(uTimerID, uMessage: UINT;
    dwUser, dw1, dw2: DWORD) stdcall;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    PopupMenu1: TPopupMenu;
    Close1: TMenuItem;
    Chart1: TChart;
    Series1: TFastLineSeries;
    Panel1: TPanel;
    Memo1: TMemo;
    mode: TCheckBox;
    ind: TShape;
    lcom: TComboBox;
    Label2: TLabel;
    Series2: TFastLineSeries;
    LabelText: TLabel;
    tb: TTrackBar;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure modeClick(Sender: TObject);
    procedure lcomChange(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Chart1DblClick(Sender: TObject);
    procedure tbChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure rec(Sender:TObject; Buffer: pointer; BufferLength: Word);

  end;

var
  Form1: TForm1;
  


implementation
{$R *.dfm}

uses comm32, SetupAPI, DateUtils;


var  mig: boolean = true; //  -
     OrgP,OrgXY: tPoint;
     com: Tcomm32;
     gl_pila: byte = 0;
     on_trigger: boolean; //    COM
     fl: boolean = false;
     //-
     tmr2:integer;
     trm_interval: integer;
     function timeSetEvent(uDelay, uResolution: UINT;lpFunction: TFNTimeCallBack; dwUser: DWORD; uFlags: UINT): UINT;stdcall; external 'winmm.dll' name 'timeSetEvent';
     function timeKillEvent(uTimerID: UINT): UINT; stdcall; external 'winmm.dll' name 'timeKillEvent';



type tb = array[0..255] of Char;  //  
     pb = ^tb;


procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 OrgP := Point(Left, Top);
 OrgXY:= ClientToScreen(Point(X, Y))
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var _p: TPoint;
begin
 if (Shift = [ssLeft]) then begin
  _p:= ClientToScreen(Point(X, Y));
  SetBounds(OrgP.X + (_p.X - OrgXY.X),OrgP.Y + (_p.Y - OrgXY.Y), Width, Height);
 end
end;





procedure TForm1.Chart1DblClick(Sender: TObject);
begin
 fl:= not fl;
 if fl then
  WindowState:= wsMaximized
   else WindowState:= wsNormal;
 chart1.Refresh
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
 close
end;



procedure TForm1.FormCreate(Sender: TObject);
begin
 decimalseparator:= '.';
 doublebuffered:= true;
 trm_interval:= tb.Position;

 chart1.BottomAxis.Automatic:= true;
 chart1.Series[0].XValues.DateTime:= true;
 chart1.Series[1].XValues.Datetime:= true;
 Chart1.BottomAxis.DateTimeFormat := 'hh:mm:ss.zzz';
 Chart1.LeftAxis.SetMinMax(0, 280);
 chart1.doublebuffered:= true;

 //   COMM32
 com:= Tcomm32.Create(self);
 com.OnReceiveData:= rec;
 //  
 timer1.Enabled:= true
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 com.StopComm;
 com.free
end;





procedure reinit(temp: string);
var tmp: string;
begin
 if not on_trigger then begin
  //  
  com.BaudRate:= 19200; // 
  com.StopBits:= 1;    // -
  com.Bits    := 8;    // -
  com.CommPort:= temp; //  
  com.ReadInterval:= 1;

  try  //  
   if com.StartComm then begin
    form1.ind.Brush.Color:= cllime;
    on_trigger:= true;
   end
  except end

 end
end;

//     V850ES
procedure TForm1.Timer1Timer(Sender: TObject);
var temp: string;
begin
 //   NEC    
 temp:= get_num_comname('COM', 'Arduino');

 //  - ,    
 //      
 if mode.Checked then begin
  if temp = '' then begin
   com.StopComm;
   on_trigger:= false;
   ind.Brush.Color:= clred;
   //
   mig:= false;
  end else begin
   lcom.Text:= temp;
   reinit({'\\\.\\' + }temp); //\\\\.\\COM10
   ind.Brush.Color:= cllime;
  end
 end else begin

 end;
end;




//  -   
procedure Ontmr2(uTimerID, uMessage: uint;dwUser, dw1, dw2: dword) stdcall;
begin
 if on_trigger then begin
  inc(gl_pila); if gl_pila > 255 then gl_pila:= 0;

  com.WriteCommData(@gl_pila, 1);
  with form1 do begin
   series1.Addxy(time(), gl_pila, '', rgb(0, 255, 0));
   if series1.Count >255 then  begin
    chart1.BottomAxis.Automatic:= false;
    chart1.BottomAxis.Minimum:= chart1.BottomAxis.Minimum + strtotime('00:00:00.0' + inttostr(trm_interval));
    chart1.BottomAxis.Maximum:= chart1.BottomAxis.Maximum + strtotime('00:00:00.0' + inttostr(trm_interval));
   end;
  LabelText.caption:= format('[%3d ms] %3d',[trm_interval, gl_pila]) + formatdatetime(' - hh:mm:ss', time);
  end
 end
end;


procedure TForm1.rec(Sender:TObject; Buffer: pointer; BufferLength: Word);
var PX: pb;
begin
 PX:= buffer;
 //  ==============================================================
 series2.Addxy(time(), ord(PX^[0]), '', rgb(0, 255, 0));
end;


procedure TForm1.lcomChange(Sender: TObject);
begin
 if not mode.Checked then begin
  if tmr2<> 0 then
   timeKillEvent(tmr2);
  //
  com.StopComm;
  on_trigger:= false;
  Memo1.Lines.Add('COM not connected...');
  mig:= false;
  //
  reinit(lcom.Text); //\\\\.\\COM10
  Memo1.Lines.Add(com.CommPort + ' connected...');
  tmr2:= timesetevent(trm_interval, 0, @Ontmr2, 0, 1);
 end;
end;

procedure TForm1.modeClick(Sender: TObject);
begin
 lcom.Enabled:= not mode.Checked;
 if not lcom.Enabled then begin
  com.StopComm;
  on_trigger:= false;
  Memo1.Lines.Add('COM not connected...');
  mig:= false; Form1.OnPaint(nil);
 end;
end;


procedure TForm1.tbChange(Sender: TObject);
begin
 trm_interval:= tb.Position;

 if tmr2<> 0 then
  timeKillEvent(tmr2);
 tmr2:= timesetevent(trm_interval, 0, @Ontmr2, 0, 1);
end;



end.

